<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="redux-store.html">
<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/app-storage/app-localstorage/app-localstorage-document.html">
<link rel="import" href="../bower_components/iron-pages/iron-pages.html">
<link rel="import" href="../bower_components/iron-icons/iron-icons.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="../bower_components/app-layout/app-grid/app-grid-style.html">
<!-- <link rel="import" href="../bower_components/paper-collapse-item/paper-collapse-item.html"> -->
<link rel="import" href="../bower_components/iron-selector/iron-selector.html">
<link rel="import" href="../bower_components/iron-scroll-threshold/iron-scroll-threshold.html">

<link rel="import" href="collection-observer.html">

<link rel="import" href="../bower_components/paper-material/paper-material.html">
<link rel="import" href="../bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../bower_components/paper-tabs/paper-tab.html">
<link rel="import" href="../bower_components/paper-tabs/paper-tabs.html">
<link rel="import" href="../bower_components/paper-dropdown-menu/paper-dropdown-menu.html">
<!-- <link rel="import" href="../bower_components/titanium-date-input/titanium-date-input.html"> -->

<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../bower_components/paper-listbox/paper-listbox.html">
<link rel="import" href="../bower_components/paper-item/paper-item.html">
<link rel="import" href="../bower_components/paper-fab/paper-fab.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">

<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-column-group.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-sorter.html">

<link rel="import" href="../bower_components/vaadin-date-picker/vaadin-date-picker.html">

<link rel="import" href="food-order.html">
<link rel="import" href="food-cart.html">

<dom-module id="food-order-analytics">

  <template>
    <style is="custom-style" include="iron-flex iron-flex-alignment iron-positioning"></style>
    <style include="paper-material-shared-styles"></style>
    <style>
        :host {
              display: block;
              /* min-height: 100vh; */
      
          }

        :host paper-material[name="order"], 
        :host paper-material[name="kitchen"],
        :host paper-material[name="delivery"]
        {
            display: block;
            padding: 24px 16px;
            margin: 8px;
        }
        :host paper-material[name="kitchen"][status="cooked"] food-cart-item
        {
            display: none;
        }

  </style>
  <style include="app-grid-style">
        
        div[name="orders"] {
        
            --app-grid-columns: 2;         
        }

        [name="order"]
        {
            overflow: auto;
        }
     
        @media (max-width: 640px) {

            div[name="orders"] {
                --app-grid-columns: 1;
            }

            [name=order]
            {
                max-width: 100vw;
            }
        }
        
      
        .header h2 {
            color: #2196F3;
            text-transform: uppercase;
            font-weight: 400;
            font-size: 0.8rem;
        }
        
        h2 {
            color: darkslategray;
            /* text-transform: uppercase; */
            font-weight: 300;
            font-size: 0.8rem;
        }

        paper-collapse-item
        {
            background: white;
        }
        
        [name="order"][new] h2[name=number]
        {
            color: green;
        }

        [name="order"][cancelled] h2[name=number]
        {
            color: orange;
        }

       :host food-cart
      {
        max-height: 380px;
        overflow: auto;
      }
      #total
      { 
        font-weight: bold;
        text-align: right;
        margin-right: 10px;
      }
      .total-row
      {
        margin: 24px 0;
      }
      food-cart
      {
        --food-cart-header: {
          display: none;
        };
  
        --food-cart-total: {
          display: none;
        };
      }
        
      vaadin-grid 
      {
          width: 100%;
          height: 800px;
      }

    </style>
      <collection-observer name="orders" subscribed=[[subscribed]]></collection-observer>

      <iron-scroll-threshold id="theshold"
            lower-threshold="500"
            on-lower-threshold="_loadMoreData"
            lower-triggered="{{spinnerShouldShow}}"
            scroll-target="grid">
        </iron-scroll-threshold>
        <!-- <iron-list id="list" scroll-target="list-content" items="[[orders]]">
            <template>
                
                <div class="layout horizontal flex center" tabindex$="[[tabIndex]]" on-tap="_open">
              
                    <div class="layout horizontal justified">
                        <h2>[[item.name]]</h2><h2>[[item.phone]]</h2>
                    </div>                             
                </div>  
            </template>            
        </iron-list>  -->

        <div class="">       
                <div class="layout horizontal  around-justified">  
                    
                    <div class="layout horizontal center start-justified">  
                        <vaadin-date-picker id="fromDate" label="От"></vaadin-date-picker>
                        <vaadin-date-picker id="toDate" label="До"></vaadin-date-picker>

                        <!-- <titanium-date-input label="от" value={{fromDate}} date-pattern="DD/MM/YYYY" placeholder="dd/mm/yyyy"></titanium-date-input>    -->
                        <!-- <titanium-date-input label="до" value={{toDate}}></titanium-date-input>  -->
                        <paper-button on-tap="_sendReport">Отправить отчет</paper-button>  
                        <paper-icon-button icon="close" on-tap="_resetDate"></paper-icon-button>
                    </div>

                    <div class="layout horizontal center end-justified">  
                        <h1>[[skip]]-[[_limit(skip,limit,orders.length)]]</h1>
                        <paper-icon-button icon="icons:chevron-left" on-tap="_listPrev"></paper-icon-button>
                        <paper-icon-button icon="icons:chevron-right" on-tap="_listNext"></paper-icon-button>

                        <paper-dropdown-menu no-animations no-label-float style="max-width: 50px">
                                <paper-listbox slot="dropdown-content"
                                        selected={{limit}}
                                        attr-for-selected="value">
                                        
                                        <template is="dom-repeat" items="[[limits]]">                                                                  
                                            <paper-item value="[[item]]">
                                                <div>[[item]]</div>
                                            </paper-item>
                                        </template>
                                </paper-listbox>
                            </paper-dropdown-menu>
                    </div>                            
                </div> 
                <vaadin-grid id="grid" aria-label="Заказы" items="[[orders]]" on-active-item-changed="_onActiveItemChanged">
                <template class="row-details">
                
                    <div class="layout horizontal around-justified"> 
                       
                        <div>
                            <div class="layout horizontal justified">
                                <h2>[[item.name]]</h2><h2>[[item.phone]]</h2>
                            </div> 
                            <div class="layout horizontal justified">                                
                                <h2>[[item.address]]</h2>
                            </div>
                            <div class="layout horizontal justified">                                
                                <h2>[[item.deliveryZoneName]]</h2>
                            </div>                            
                            <div class="layout horizontal justified">  
                                <h2 class="header">Доставка</h2>
                                <h2>[[_humanReadableTime(item.delivery)]]</h2>
                            </div>
                            <div class="layout horizontal justified">                          
                                <h2>[[item.comment]]</h2>
                            </div>
                        </div>
                        <food-order class="details" order=[[item]] small></food-order>  
                        <food-cart cart="[[item.cart]]" readonly></food-cart>
                    </div>
         
                </template>
                  
                <vaadin-grid-column width="60px" flex-grow="0">
                    <template class="header">#</template>
                    <template>[[_index(index)]]</template>
                </vaadin-grid-column>
            
                <vaadin-grid-column>
                    <template class="header">
                    <vaadin-grid-sorter path="name.number">Номер</vaadin-grid-sorter>
                    </template>
                    <template>[[item.number]]</template>
                </vaadin-grid-column>
                  
                <vaadin-grid-column>
                    <template class="header">
                    <vaadin-grid-sorter path="name.status" direction="asc">Статус</vaadin-grid-sorter>
                    </template>
                    <template>[[item.status]]</template>
                </vaadin-grid-column>
                <vaadin-grid-column>
                    <template class="header">
                    <vaadin-grid-sorter path="name.pay" direction="asc">Оплата</vaadin-grid-sorter>
                    </template>
                    <template>[[_deliveryTotalLabel(item.payment,item.pay)]]</template>
                </vaadin-grid-column>

                <vaadin-grid-column>
                    <template class="header">
                    <vaadin-grid-sorter path="name.delivery" direction="asc">Доставка</vaadin-grid-sorter>
                    </template>
                    <template>[[item.delivery]]</template>
                </vaadin-grid-column>
            
                <vaadin-grid-column>
                    <template class="header">
                    <vaadin-grid-sorter path="name.address" direction="asc">Адрес</vaadin-grid-sorter>
                    </template>
                    <template>[[item.address]]</template>
                </vaadin-grid-column>
                
                <vaadin-grid-column>
                    <template class="header">
                    <vaadin-grid-sorter path="name.number">Контакты</vaadin-grid-sorter>
                    </template>
                    <template>[[_contacts(item.userId, item.phone)]]</template>
                </vaadin-grid-column>
                <vaadin-grid-column>                                                    
                    <template><paper-icon-button icon="close" on-tap="_removeOrder"></paper-icon-button></template>
                </vaadin-grid-column>
                </vaadin-grid>
            </div> 
      </div>



    <!-- > Product ( category, type , business logic of client )

    > Order ( flow , state )  - Cart = creates order, user just approve?(register)

    > Delivery  ( map, delivery position, user administration / user profiles ) -->

        
  </template>

  <script>

    class FoodOrderAnalytics extends ReduxMixin(Polymer.Element) {

      static get is() { return 'food-order-analytics'; }
      static get observers() {
                return [
                    // '_computeOrders(immutableOrders)',
                '_subscriptionChanged(skip,limit)']
            }
      static get properties() { return {
        dictionary:{
          type: Array,
          statePath: 'dev.dictionary'
        },     
        immutableOrders: {
            type: Object,
            statePath: "orders.items"
        }, 
        brief: {
            type: Boolean,
            value: false
        },
        orders: {
            type: Array,
            value: [],
        },  
        skip:{
            type: Number,
            value: 0            
        },
        limit: {
            type: Number,
            value: 30
        },
        limits: {
            type: Array,
            value: [10, 30, 50, 100]
        }  
      }}
      _sendReport()
      {
          Meteor.call('generateReport', this.$.fromDate._selectedDate, this.$.toDate._selectedDate);
      }
      _contacts(userId, phone)
        {
            var user = Meteor.users.findOne(userId);

            return phone ? phone : user && user.emails && user.emails[0]? user.emails[0].address:"";
        }

      _index(index)
      {
          return index + this.skip + 1;
      }

      _deliveryTotalLabel(payment, pay)
        {
            if( pay == 'online')
                return payment==="completed" ? "Оплачено": "Онлайн: не оплачено";       
            
            return payment==="completed"?"Oплачено": "По доставке";
        }
      
      _loadMoreData()
      {
        // this._listNext();  
      }

      _limit(skip,limit,count)
      {
         return (skip + limit)
      }

      _listNext()
      {
        this.dispatch({
                        type: "SET_COLLECTION", 
                        name: "orders",
                        items: {}
                    }); 
          this.skip += this.limit;
      }
      _listPrev()
      {
        this.dispatch({
                        type: "SET_COLLECTION", 
                        name: "orders",
                        items: {}
                    }); 
        if( this.skip - this.limit >= 0)
        {
            this.skip -= this.limit;
        }else
        {
            this.skip = 0;
        }
        
      }
      _subscriptionChanged(skip,limit)
      {
          if(this.handle)
             this.handle.stop()
            
             this.handle = Meteor.subscribe('orders',this.skip, this.limit, ()=>this.orders = Orders.find().fetch());
      }

      _onActiveItemChanged(e) {
          this.$.grid.detailsOpenedItems = [e.detail.value];
        }

      _sortByTimestamp( a, b) {

            a = new Date(a.timestamp);
            b = new Date(b.timestamp);
            return a>b ? -1 : a<b ? 1 : 0;
        };


      _status(status)
      {
        if(status === 'new')
            return 'Новый';
        if(status === 'cancelled')
            return 'Отменен';
      }

      _humanReadableTime(time)
      {
        return fecha.format(time, 'HH:mm DD MMMM YYYY');
      }

      _hasDiscount(discount)
      {
        return !!discount
      }

      _formatTotal(total) {

        return isNaN(total) ? '' : parseFloat(total).toFixed(2) + ' руб.';
      }

      _orderIsNew(status)
      {
        return status === 'new'
      }
      _orderIsCancelled(status)
      {
        return status === 'cancelled'
      }

      _orderPaymentState(pay,payment)
      {
        return payment === 'completed' ? "Оплачено" : pay === 'delivery' ? "Оплата по доставке":"";
      }

      _formatPrice(total) {
        return isNaN(total) ? '' : total + ' руб.';//'$' + total.toFixed(2);
      }

      _getPluralizedQuantity(quantity) {
        return quantity + ' ' + (quantity === 1 ? 'позиция' : 'позиций');
      }

      _humanReadableTime(time)
      {
        return fecha.format(time, 'HH:mm DD MMMM YYYY');
      }

      _selectedPayment(payment)
      {
         return payment == 'delivery' ? "По доставке":"Исполнено"
      }

      _computeOrders(immutable)
      {
          console.log("#orders",immutable)
          var array = _.values(immutable);
          if( array.length )
          {                
              var splices = Polymer.ArraySplice.calculateSplices(array, this.orders);

              // Copy content
              this.orders.length = 0;
              this.orders.push(...array);

              // Inform Polymer about changes
              this.notifySplices('orders', splices);               
          }
      
      }
     
        connectedCallback() {
            super.connectedCallback();
            window.dev = this;

            // Tracker.autorun(() => {
            //     this._subscriptionChanged(this.skip,this.limit);
            // });
            // console.log('food-orders created!');
        }
       
        _cancelOrder(e)
        {
            Meteor.call("cancelOrder", e.model.item._id);
        }
        _removeOrder(e)
        {
            Meteor.call("hideOrder", e.model.item._id);

            this._subscriptionChanged();
        }



    }

    customElements.define(FoodOrderAnalytics.is, FoodOrderAnalytics);

  </script>

</dom-module>
